
#include <dbsim.h>
#include <disk.h>
#include <strings.h>
#include <math.h>

//------------------------------------------------------------------------
// class implementation for DiskReq
//------------------------------------------------------------------------


DiskReq* DiskReq::freeReq = NULL;	// no free disk requests initially


void* DiskReq::operator new(size_t size)
{
    DiskReq *newReq;

    if (freeReq == NULL) {
	// allocate a new disk request
	newReq = (DiskReq *) new char[size];
        newReq->ioReady = new global_event("ioReady");
    } else {
	// reuse an existing disk request
        newReq = freeReq;
	freeReq = freeReq->nextReq;
    }
    return newReq;
};


void DiskReq::operator delete(void* oldReq, size_t)
{
    // put the disk request on the free list
    ((DiskReq *) oldReq)->nextReq = freeReq;
    freeReq = (DiskReq *) oldReq;
};


DiskReq::DiskReq(int pageId, int prefReq)
{
    page     = pageId;
    cylinder = pageId / PagesPerCyl;
    prefetch = prefReq;
};

